// Copyright 2022 Bitcoding

import 'package:flutter/material.dart';
import 'package:google_applovin_unity_ads/google_applovin_unity_ads.dart';

class MainScreen extends StatefulWidget {
  const MainScreen({Key? key}) : super(key: key);

  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MainScreen> {
  final String placeholderText =
      """
      Subject: Application for suggestion for all saturday off in every month

      Dear Mr. Jaydeepbhai & Mr. Tusharbhai ,
      
      I am writing this letter to let you know that I am in need of a long-term leave. Thus, I would like to avail my full annual leave allotment as I have my complete yearly leave allowance.
      
      I request you to consider my leave application of thirty days as I am planning for an international vacation with my family. I would like to avail the leaves from {start date} to {end date}.
      
      I have delegated my current project to {person's name}. He/she very well understands about my project and is capable of handling the task without any difficulties. In fact, it is only the final part that is left to be carried out by him/her.
      
      During the days of my absence from office, I can be reached at {email address/contact number}.
      
      I will return to the office on {date}. In case I want to resume the work sooner or later than the stated date, I will let you know well in advance.
      
      Yours Sincerely,
      {Your Name}
      """;

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
    destroyAd();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Builder(builder: (BuildContext context) {
        return Scaffold(
          appBar: AppBar(
            title: const Text('Ads example app'),
            actions: <Widget>[
              PopupMenuButton<String>(
                onSelected: (String result) {
                  switch (result) {
                    case 'InterstitialAd':
                      showIntraAds(
                          callback: () => {print("Show Completed true")});
                      break;
                    case 'RewardedAd':
                      showRewardAds(
                          callback: () => {print("Show Completed true")});
                      break;
                    default:
                      throw AssertionError('unexpected button: $result');
                  }
                },
                itemBuilder: (BuildContext context) => <PopupMenuEntry<String>>[
                  const PopupMenuItem<String>(
                    value: 'InterstitialAd',
                    child: Text('InterstitialAd'),
                  ),
                  const PopupMenuItem<String>(
                    value: 'RewardedAd',
                    child: Text('RewardedAd'),
                  )
                ],
              ),
            ],
          ),
          body: SafeArea(child: Text(placeholderText)),
          bottomNavigationBar: showBannerAds(),
        );
      }),
    );
  }
}
