import 'dart:convert';
import 'package:google_applovin_unity_ads/ads/SettingsModel.dart';
import 'package:google_applovin_unity_ads/google_applovin_unity_ads.dart';
import 'package:http/http.dart' as http;

Settings? _settings;

InterstitialAd? _interstitialAd;
AdManagerInterstitialAd? _adManagerInterstitialAd;

AppLifecycleReactor? _appLifecycleReactor;

RewardedAd? _rewardedAd;
int _appVersionCode = 1;

int _interestialAdTimeInterval = 0;

Future<Settings?> fetchAdsSettings({required int appVersionCode, required String settingsUrl,  String? keyName}) async {
  final response = await http.get(Uri.parse(settingsUrl));
  if (response.statusCode == 200) {
    return convertAdsSettings(appVersionCode: appVersionCode, jsonData:response.body, keyName: keyName);
  } else {
    return null;
  }
}

Future<Settings?> convertAdsSettings({required int appVersionCode, required String jsonData,  String? keyName}) async {
  _appVersionCode = appVersionCode;
  if (keyName == null || keyName == "") {
    _settings = Settings.fromJson(jsonDecode(jsonData));
  } else {
    _settings = _Response.fromJson(jsonDecode(jsonData), keyName).response;
  }
  return _settings;
}


int getAppVersionCode() {
  return _appVersionCode;
}

Settings? getAdsSettings() {
  return _settings;
}

InterstitialAd? getInterestitialAd() {
  return _interstitialAd;
}

AdManagerInterstitialAd? getAdManagerInterstitialAd() {
  return _adManagerInterstitialAd;
}

AppLifecycleReactor? getAppLifecycleReactor() {
  return _appLifecycleReactor;
}

RewardedAd? getRewardedAd() {
  return _rewardedAd;
}

int getInterestialAdTimeInterval() {
  return _interestialAdTimeInterval;
}

void setInterestitialAd(InterstitialAd? _intraAd) {
  _interstitialAd = _intraAd;
}

void setAdManagerInterstitialAd(AdManagerInterstitialAd? admanagerIntraAd) {
  _adManagerInterstitialAd = admanagerIntraAd;
}

void setAppLifecycleReactor(AppLifecycleReactor? lifecycle) {
  _appLifecycleReactor = lifecycle;
}

void setRewardedAd(RewardedAd? reward) {
  _rewardedAd = reward;
}

void setInterestialAdTimeInterval(int timeInterval) {
  _interestialAdTimeInterval = timeInterval;
}

class _Response {
  Settings? response;

  _Response({this.response});

  _Response.fromJson(Map<String, dynamic> json, String keyName) {
    response = json[keyName] != null
        ? Settings.fromJson(
        json[keyName])
        : null;
  }
}